Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 86541)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 86544)
@@ -689,10 +689,4 @@
 }
 
-void UIChooserAbstractModel::sltHandleCloudProviderListChanged()
-{
-    /* Reload cloud tree: */
-    reloadCloudTree();
-}
-
 void UIChooserAbstractModel::sltHandleCloudProviderUninstall(const QUuid &uId)
 {
@@ -785,5 +779,5 @@
 }
 
-void UIChooserAbstractModel::sltHandleCloudProfileManagerRestrictionChange()
+void UIChooserAbstractModel::sltHandleCloudProfileManagerCumulativeChange()
 {
     /* Reload cloud tree: */
@@ -824,5 +818,5 @@
             this, &UIChooserAbstractModel::sltSnapshotChanged);
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProviderListChanged,
-            this, &UIChooserAbstractModel::sltHandleCloudProviderListChanged);
+            this, &UIChooserAbstractModel::sltHandleCloudProfileManagerCumulativeChange);
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProviderUninstall,
             this, &UIChooserAbstractModel::sltHandleCloudProviderUninstall);
@@ -835,5 +829,5 @@
     /* Setup extra-data connections: */
     connect(gEDataManager, &UIExtraDataManager::sigCloudProfileManagerRestrictionChange,
-            this, &UIChooserAbstractModel::sltHandleCloudProfileManagerRestrictionChange);
+            this, &UIChooserAbstractModel::sltHandleCloudProfileManagerCumulativeChange);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h	(revision 86541)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h	(revision 86544)
@@ -154,6 +154,4 @@
         /** Handles snapshot change for machine/snapshot with certain @a uMachineId / @a uSnapshotId. */
         virtual void sltSnapshotChanged(const QUuid &uMachineId, const QUuid &uSnapshotId);
-        /** Handles event about cloud provider list changed. */
-        virtual void sltHandleCloudProviderListChanged();
         /** Handles event about cloud provider with @a uId being uninstalled. */
         virtual void sltHandleCloudProviderUninstall(const QUuid &uId);
@@ -170,6 +168,6 @@
         /** Handles list cloud machines task complete signal. */
         virtual void sltHandleCloudListMachinesTaskComplete(UITask *pTask);
-        /** Handles Cloud Profile Manager restriction change. */
-        virtual void sltHandleCloudProfileManagerRestrictionChange();
+        /** Handles Cloud Profile Manager cumulative change. */
+        virtual void sltHandleCloudProfileManagerCumulativeChange();
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 86541)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 86544)
@@ -1194,8 +1194,8 @@
 }
 
-void UIChooserModel::sltHandleCloudProfileManagerRestrictionChange()
+void UIChooserModel::sltHandleCloudProfileManagerCumulativeChange()
 {
     /* Call to base-class: */
-    UIChooserAbstractModel::sltHandleCloudProfileManagerRestrictionChange();
+    UIChooserAbstractModel::sltHandleCloudProfileManagerCumulativeChange();
 
     /* Build tree for main root: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 86541)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 86544)
@@ -282,6 +282,6 @@
         /** Handles list cloud machines task complete signal. */
         virtual void sltHandleCloudListMachinesTaskComplete(UITask *pTask) /* override */;
-        /** Handles Cloud Profile Manager restriction changes. */
-        virtual void sltHandleCloudProfileManagerRestrictionChange() /* override */;
+        /** Handles Cloud Profile Manager cumulative changes. */
+        virtual void sltHandleCloudProfileManagerCumulativeChange() /* override */;
     /** @} */
 