Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp	(revision 86544)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp	(revision 86545)
@@ -29,4 +29,6 @@
 #include "CCanShowWindowEvent.h"
 #include "CClipboardModeChangedEvent.h"
+#include "CCloudProfileChangedEvent.h"
+#include "CCloudProfileRegisteredEvent.h"
 #include "CCloudProviderListChangedEvent.h"
 #include "CCloudProviderUninstallEvent.h"
@@ -334,4 +336,16 @@
             break;
         }
+        case KVBoxEventType_OnCloudProfileRegistered:
+        {
+            CCloudProfileRegisteredEvent comEventSpecific(pEvent);
+            emit sigCloudProfileRegistered(comEventSpecific.GetProviderId(), comEventSpecific.GetName(), comEventSpecific.GetRegistered());
+            break;
+        }
+        case KVBoxEventType_OnCloudProfileChanged:
+        {
+            CCloudProfileChangedEvent comEventSpecific(pEvent);
+            emit sigCloudProfileChanged(comEventSpecific.GetProviderId(), comEventSpecific.GetName());
+            break;
+        }
 
         case KVBoxEventType_OnExtraDataCanChange:
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h	(revision 86544)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h	(revision 86545)
@@ -107,4 +107,8 @@
         /** Notifies about cloud provider list changed. */
         void sigCloudProviderListChanged();
+        /** Notifies about cloud profile with specified @a strName of provider with specified @a uProviderId is @a fRegistered. */
+        void sigCloudProfileRegistered(const QUuid &uProviderId, const QString &strName, bool fRegistered);
+        /** Notifies about cloud profile with specified @a strName of provider with specified @a uProviderId is changed. */
+        void sigCloudProfileChanged(const QUuid &uProviderId, const QString &strName);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.cpp	(revision 86544)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.cpp	(revision 86545)
@@ -55,4 +55,8 @@
     /** Notifies about cloud provider list changed. */
     void sigCloudProviderListChanged();
+    /** Notifies about cloud profile with specified @a strName of provider with specified @a uProviderId is @a fRegistered. */
+    void sigCloudProfileRegistered(const QUuid &uProviderId, const QString &strName, bool fRegistered);
+    /** Notifies about cloud profile with specified @a strName of provider with specified @a uProviderId is changed. */
+    void sigCloudProfileChanged(const QUuid &uProviderId, const QString &strName);
 
     /** Notifies about storage controller change.
@@ -164,4 +168,6 @@
         << KVBoxEventType_OnCloudProviderListChanged
         << KVBoxEventType_OnCloudProviderUninstall
+        << KVBoxEventType_OnCloudProfileRegistered
+        << KVBoxEventType_OnCloudProfileChanged
         << KVBoxEventType_OnStorageControllerChanged
         << KVBoxEventType_OnStorageDeviceChanged
@@ -212,4 +218,10 @@
             this, SIGNAL(sigCloudProviderUninstall(QUuid)),
             Qt::DirectConnection);
+    connect(m_pQtListener->getWrapped(), SIGNAL(sigCloudProfileRegistered(QUuid, QString, bool)),
+            this, SIGNAL(sigCloudProfileRegistered(QUuid, QString, bool)),
+            Qt::DirectConnection);
+    connect(m_pQtListener->getWrapped(), SIGNAL(sigCloudProfileChanged(QUuid, QString)),
+            this, SIGNAL(sigCloudProfileChanged(QUuid, QString)),
+            Qt::DirectConnection);
     connect(m_pQtListener->getWrapped(), SIGNAL(sigStorageControllerChange(QUuid, QString)),
             this, SIGNAL(sigStorageControllerChange(QUuid, QString)),
@@ -324,4 +336,10 @@
             this, SIGNAL(sigCloudProviderUninstall(QUuid)),
             Qt::BlockingQueuedConnection);
+    connect(m_pProxy, SIGNAL(sigCloudProfileRegistered(QUuid, QString, bool)),
+            this, SIGNAL(sigCloudProfileRegistered(QUuid, QString, bool)),
+            Qt::QueuedConnection);
+    connect(m_pProxy, SIGNAL(sigCloudProfileChanged(QUuid, QString)),
+            this, SIGNAL(sigCloudProfileChanged(QUuid, QString)),
+            Qt::QueuedConnection);
     connect(m_pProxy, SIGNAL(sigStorageControllerChange(QUuid, QString)),
             this, SIGNAL(sigStorageControllerChange(QUuid, QString)),
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.h	(revision 86544)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.h	(revision 86545)
@@ -63,4 +63,8 @@
     /** Notifies about cloud provider list changed. */
     void sigCloudProviderListChanged();
+    /** Notifies about cloud profile with specified @a strName of provider with specified @a uProviderId is @a fRegistered. */
+    void sigCloudProfileRegistered(const QUuid &uProviderId, const QString &strName, bool fRegistered);
+    /** Notifies about cloud profile with specified @a strName of provider with specified @a uProviderId is changed. */
+    void sigCloudProfileChanged(const QUuid &uProviderId, const QString &strName);
 
     /** Notifies about storage controller change.
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 86544)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 86545)
@@ -818,4 +818,8 @@
             this, &UIChooserAbstractModel::sltSnapshotChanged);
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProviderListChanged,
+            this, &UIChooserAbstractModel::sltHandleCloudProfileManagerCumulativeChange);
+    connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProfileRegistered,
+            this, &UIChooserAbstractModel::sltHandleCloudProfileManagerCumulativeChange);
+    connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProfileChanged,
             this, &UIChooserAbstractModel::sltHandleCloudProfileManagerCumulativeChange);
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProviderUninstall,