Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 86557)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 86569)
@@ -637,5 +637,5 @@
 
 void UIChooserAbstractModel::sltCloudMachineRegistered(const QString &strProviderShortName, const QString &strProfileName,
-                                                       const QUuid &uMachineId, const bool fRegistered)
+                                                       const QUuid &uId, const bool fRegistered)
 {
     /* Search for profile node: */
@@ -651,5 +651,5 @@
     {
         /* Remove machine-items with passed id: */
-        pProfileNode->removeAllNodes(uMachineId);
+        pProfileNode->removeAllNodes(uId);
 
         /* If there are no items left: */
@@ -666,5 +666,5 @@
     {
         /* Add new machine-item: */
-        const CCloudMachine comMachine = cloudMachineById(strProviderShortName, strProfileName, uMachineId);
+        const CCloudMachine comMachine = cloudMachineById(strProviderShortName, strProfileName, uId);
         addCloudMachineIntoTheTree(strProfileNodeName, comMachine, true /* make it visible */);
 
@@ -735,9 +735,11 @@
 {
     /* Skip unrelated tasks: */
-    if (!pTask || pTask->type() != UITask::Type_CloudListMachines)
+    AssertPtrReturnVoid(pTask);
+    if (pTask->type() != UITask::Type_CloudListMachines)
         return;
 
     /* Cast task to corresponding sub-class: */
-    UITaskCloudListMachines *pAcquiringTask = static_cast<UITaskCloudListMachines*>(pTask);
+    UITaskCloudListMachines *pAcquiringTask = qobject_cast<UITaskCloudListMachines*>(pTask);
+    AssertPtrReturnVoid(pAcquiringTask);
 
     /* Search for profile node: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h	(revision 86557)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h	(revision 86569)
@@ -149,5 +149,5 @@
           * @param  strProfileName        Brings profile name. */
         virtual void sltCloudMachineRegistered(const QString &strProviderShortName, const QString &strProfileName,
-                                               const QUuid &uMachineId, const bool fRegistered);
+                                               const QUuid &uId, const bool fRegistered);
         /** Handles session @a enmState change for machine with certain @a uMachineId. */
         virtual void sltSessionStateChanged(const QUuid &uMachineId, const KSessionState enmState);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 86557)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 86569)
@@ -1110,5 +1110,5 @@
 }
 
-void UIChooserModel::sltCloudMachineRegistered(const QString &strProviderName, const QString &strProfileName,
+void UIChooserModel::sltCloudMachineRegistered(const QString &strProviderShortName, const QString &strProfileName,
                                                const QUuid &uId, const bool fRegistered)
 {
@@ -1118,5 +1118,5 @@
 
     /* Call to base-class: */
-    UIChooserAbstractModel::sltCloudMachineRegistered(strProviderName, strProfileName, uId, fRegistered);
+    UIChooserAbstractModel::sltCloudMachineRegistered(strProviderShortName, strProfileName, uId, fRegistered);
 
     /* Existing VM unregistered? */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 86557)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 86569)
@@ -264,7 +264,7 @@
         virtual void sltLocalMachineRegistered(const QUuid &uId, const bool fRegistered) /* override */;
         /** Handles cloud machine registering/unregistering for machine with certain @a uId.
-          * @param  strProviderName  Brings provider short name.
-          * @param  strProfileName   Brings profile name. */
-        virtual void sltCloudMachineRegistered(const QString &strProviderName, const QString &strProfileName,
+          * @param  strProviderShortName  Brings provider short name.
+          * @param  strProfileName        Brings profile name. */
+        virtual void sltCloudMachineRegistered(const QString &strProviderShortName, const QString &strProfileName,
                                                const QUuid &uId, const bool fRegistered);
         /** Handles event about cloud provider with @a uId being uninstalled. */