Index: /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp	(revision 86688)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp	(revision 86689)
@@ -84,4 +84,7 @@
     /** Returns item name. */
     QString name() const { return m_strName; }
+
+    /** Returns definition composed on the basis of @a strShortName. */
+    static QString definition(const QString &strShortName);
 };
 
@@ -101,4 +104,7 @@
     /** Returns item name. */
     QString name() const { return m_strName; }
+
+    /** Returns definition composed on the basis of @a strProviderShortName and @a strName. */
+    static QString definition(const QString &strProviderShortName, const QString &strName);
 };
 
@@ -121,6 +127,12 @@
     setText(Column_Name, m_strName);
     setData(Column_Name, Data_ProviderID, m_uId);
-    setData(Column_Name, Data_Definition, QVariant::fromValue(QString("/%1").arg(m_strShortName)));
+    setData(Column_Name, Data_Definition, QVariant::fromValue(definition(m_strShortName)));
     setCheckState(Column_ListVMs, m_fRestricted ? Qt::Unchecked : Qt::Checked);
+}
+
+/* static */
+QString UIItemCloudProvider::definition(const QString &strShortName)
+{
+    return QString("/%1").arg(strShortName);
 }
 
@@ -142,6 +154,12 @@
     /* Update item fields: */
     setText(Column_Name, m_strName);
-    setData(Column_Name, Data_Definition, QVariant::fromValue(QString("/%1/%2").arg(m_strProviderShortName, m_strName)));
+    setData(Column_Name, Data_Definition, QVariant::fromValue(definition(m_strProviderShortName, m_strName)));
     setCheckState(Column_ListVMs, m_fRestricted ? Qt::Unchecked : Qt::Checked);
+}
+
+/* static */
+QString UIItemCloudProfile::definition(const QString &strProviderShortName, const QString &strName)
+{
+    return QString("/%1/%2").arg(strProviderShortName, strName);
 }
 
@@ -801,5 +819,6 @@
 
         /* Make sure provider item is properly inserted: */
-        UIItemCloudProvider *pItem = searchItem(providerData.m_uId);
+        QTreeWidgetItem *pItem = searchItem(UIItemCloudProvider::definition(providerData.m_strShortName));
+        AssertPtrReturnVoid(pItem);
 
         /* Iterate through provider's profiles: */
@@ -841,5 +860,5 @@
     if (comProvider.isOk())
         providerData.m_strName = comProvider.GetName();
-    const QString strProviderPath = QString("/%1").arg(providerData.m_strShortName);
+    const QString strProviderPath = UIItemCloudProvider::definition(providerData.m_strShortName);
     providerData.m_fRestricted = restrictions.contains(strProviderPath);
     foreach (const QString &strSupportedPropertyName, comProvider.GetSupportedPropertyNames())
@@ -862,5 +881,5 @@
     if (comProfile.isOk())
         profileData.m_strName = comProfile.GetName();
-    const QString strProfilePath = QString("/%1/%2").arg(providerData.m_strShortName).arg(profileData.m_strName);
+    const QString strProfilePath = UIItemCloudProfile::definition(providerData.m_strShortName, profileData.m_strName);
     profileData.m_fRestricted = restrictions.contains(strProfilePath);
 
@@ -911,14 +930,4 @@
             return pChildItem;
 
-    /* Null by default: */
-    return 0;
-}
-
-UIItemCloudProvider *UICloudProfileManagerWidget::searchItem(const QUuid &uId) const
-{
-    /* Iterate through tree-widget children: */
-    for (int i = 0; i < m_pTreeWidget->childCount(); ++i)
-        if (m_pTreeWidget->childItem(i)->data(Column_Name, Data_ProviderID).toUuid() == uId)
-            return qobject_cast<UIItemCloudProvider*>(m_pTreeWidget->childItem(i));
     /* Null by default: */
     return 0;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.h	(revision 86688)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.h	(revision 86689)
@@ -169,6 +169,4 @@
         QTreeWidgetItem *searchItem(const QString &strDefinition,
                                     QTreeWidgetItem *pParentItem = 0) const;
-        /** Searches for a provider item with specified @a uId. */
-        UIItemCloudProvider *searchItem(const QUuid &uId) const;
 
         /** Creates a new tree-widget item